//
// Copyright (c) Microsoft Corporation. All rights reserved.
//
// DO NOT HAND-EDIT THIS FILE.
//
// This file was generated by setup_public_headers.py script.
// Any changes made to this file will be overwritten.

/**
 * @file att_logger_exports.h
 *
 * @brief Defines the logging symbols for the SDK.
 *
 * @note You MUST NOT use any symbols (macros, functions, structures, enums, etc.)
 * prefixed with an underscore ('_') directly in your application code. These symbols
 * are part of the SDK's internal implementation; we do not document these symbols
 * and they are subject to change in future versions of the SDK which would break your code.
 */

#ifndef _ATT_LOGGER_EXPORTS_H
#define _ATT_LOGGER_EXPORTS_H
#include <stdarg.h>

/**
 * @brief Defines the logging levels for the SDK.
 * none - Logging is disabled.
 * error = Logging level for failures that the application cannot recover from.
 * warning - Logging level when a function fails to perform its intended task.
 * info - Logging level for normally operating functions.
 * telemetry - Logging level for detailed troubleshooting scenarios.
 */
enum att_log_level
{
    att_log_level_none = 0,
    att_log_level_error = 1,
    att_log_level_warning = 2,
    att_log_level_info = 3,
    att_log_level_telemetry = 4,
};

/**
 * @brief Describes where the log originated from.
 * host - The log originated from the host application.
 * enclave - The log originated from the enclave. This is currently only
 * applicable on Windows.
 */
enum att_log_source
{
    att_log_source_invalid = 0,
    att_log_source_host = 1,
    att_log_source_enclave = 2,
};

/**
 * @brief Function definition that will be invoked to report a log message.
 * @param[in] log_source The source of the log message.
 * @param[in] level The logging level of the message.
 * @param[in] message The log message.
 */
typedef void (*PATT_LOGGER_FUNC)(
    att_log_source log_source,
    att_log_level level,
    const char* message);

#endif // _ATT_LOGGER_EXPORTS_H